﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Public Class Card_Caption_Images_DrawFilter
    Implements IUIElementDrawFilter

#Region "Implementation of IUIElementDrawFilter"

    Public Function GetPhasesToFilter(ByRef drawParams As Infragistics.Win.UIElementDrawParams) As Infragistics.Win.DrawPhase Implements Infragistics.Win.IUIElementDrawFilter.GetPhasesToFilter
        'Check for a CardCaptionUIElement
        If TypeOf drawParams.Element Is CardCaptionUIElement Then
            'Return BeforeDrawForeground so we can intercept the element
            Return DrawPhase.BeforeDrawBackColor
        End If
        Return DrawPhase.None

    End Function


    Public Function DrawElement(drawPhase As Infragistics.Win.DrawPhase, ByRef drawParams As Infragistics.Win.UIElementDrawParams) As Boolean Implements Infragistics.Win.IUIElementDrawFilter.DrawElement

        Dim objRow As UltraGridRow

        'Get the row we are dealing with. This is to we can determine the
        'color based on the data in the row.
        objRow = TryCast(drawParams.Element.GetContext(GetType(UltraGridRow)), UltraGridRow)

        If objRow IsNot Nothing Then
            If CBool(objRow.Cells("Bool").Value) Then
                drawParams.AppearanceData.ForeColor = Drawing.Color.DarkBlue
                drawParams.AppearanceData.BackColor = System.Drawing.Color.FromArgb(CType(CType(215, Byte), Integer), CType(CType(235, Byte), Integer), CType(CType(255, Byte), Integer))
            Else
                drawParams.AppearanceData.ForeColor = System.Drawing.Color.FromArgb(CType(CType(112, Byte), Integer), CType(CType(112, Byte), Integer), CType(CType(112, Byte), Integer))
                drawParams.AppearanceData.BackColor = Drawing.Color.LightGray
            End If
        End If
        Return False

    End Function
#End Region
End Class
Public Class Card_Caption_Images_CreationFilter
    Implements IUIElementCreationFilter

    Public Sub AfterCreateChildElements(parent As Infragistics.Win.UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements

        ' Get the TextUIElement of the CardCaptionUIElement
        If TypeOf parent Is TextUIElement And TypeOf parent.Parent Is CardCaptionUIElement Then
            ' check if CardCaptionUIElement hasn't ImageUIElement
            If parent.Parent.GetDescendant(GetType(ImageUIElement)) Is Nothing Then
                Dim objGrid As UltraGrid = TryCast(parent.Control, UltraWinGrid.UltraGrid)
                Dim objRow As UltraGridRow = TryCast(parent.GetContext(GetType(UltraGridRow)), UltraGridRow)
                Dim objImageList As ImageList = objGrid.ImageList
                Dim objImage As Image = objImageList.Images(0)

                Dim objImageUIElement As ImageUIElement = New ImageUIElement(parent, objImage)
                ' narrow the size of TextUIElement in order to have enaugh space for Image
                parent.Rect = New Rectangle(parent.Rect.Location,
                                             New Size(parent.Parent.Rect.Width - 18, parent.Parent.Rect.Height))
                Dim imgLocation As Point = parent.Rect.Location
                imgLocation.Offset(parent.Rect.Width - 1, (parent.Rect.Height - 16) / 2)
                objImageUIElement.Rect = New Rectangle(imgLocation, New Size(16, 16))
                parent.Parent.ChildElements.Add(objImageUIElement)
            End If


        End If
    End Sub

    Public Function BeforeCreateChildElements(parent As Infragistics.Win.UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements

        Return False

    End Function
End Class
